Index: /branches/HTM-15.1-dev0-NICT/source/Lib/TLibCommon/SEI.cpp
===================================================================
--- /branches/HTM-15.1-dev0-NICT/source/Lib/TLibCommon/SEI.cpp	(revision 1348)
+++ /branches/HTM-15.1-dev0-NICT/source/Lib/TLibCommon/SEI.cpp	(revision 1349)
@@ -1026,9 +1026,9 @@
 
 Void SEIDepthRepresentationInfo::setupFromCfgFile(const Char* cfgFile)
-{ 
+{
   // Set default values
-  IntAry1d defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes; 
-
-  // TBD: Add default values for which layers, POCS, Tids or Nalu types the SEI should be send. 
+  IntAry1d defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes;
+
+  // TBD: Add default values for which layers, POCS, Tids or Nalu types the SEI should be send.
   //defAppLayerIds    .push_back( TBD );
   defAppPocs        .push_back( 0 );
@@ -1036,12 +1036,12 @@
   //defAppVclNaluTypes.push_back( TBD );
 
-  Int      defSeiNaluId                  = 0; 
-  Int      defPositionInSeiNalu          = 0; 
-  Bool     defModifyByEncoder            = true; 
+  Int      defSeiNaluId                  = 0;
+  Int      defPositionInSeiNalu          = 0;
+  Bool     defModifyByEncoder            = true;
 
   // Setup config file options
-  po::Options opts;  
-
-  xAddGeneralOpts( opts , defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes, defSeiNaluId, defPositionInSeiNalu, defModifyByEncoder ); 
+  po::Options opts;
+
+  xAddGeneralOpts( opts , defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes, defSeiNaluId, defPositionInSeiNalu, defModifyByEncoder );
 
   opts.addOptions()
@@ -1165,7 +1165,7 @@
 
 Bool SEIDepthRepresentationInfo::checkCfg( const TComSlice* slice )
-{ 
+{
     // Check config values
-    Bool wrongConfig = false; 
+    Bool wrongConfig = false;
     assert(m_currLayerID>=0);
 
@@ -1175,12 +1175,12 @@
         assert(false);
     }
-    // TBD: Add constraints on presence of SEI here. 
+    // TBD: Add constraints on presence of SEI here.
     xCheckCfg     ( wrongConfig, m_depthRepresentationType[m_currLayerID][0] >=0 , "depth_representation_type must be equal to or greater than 0" );
     if ( m_dMaxFlag[m_currLayerID] || m_dMinFlag[m_currLayerID])
     {
-        xCheckCfg( wrongConfig , m_disparityRefViewId[m_currLayerID][0]>=0, "disparity_ref_view_id must be equal to or greater than 0 when d_min or d_max are present"); 
-    }
-
-    if (m_depthRepresentationType[m_currLayerID][0]==3)          
+        xCheckCfg( wrongConfig , m_disparityRefViewId[m_currLayerID][0]>=0, "disparity_ref_view_id must be equal to or greater than 0 when d_min or d_max are present");
+    }
+
+    if (m_depthRepresentationType[m_currLayerID][0]==3)
     {
         xCheckCfg(wrongConfig , m_depthNonlinearRepresentationNumMinus1[m_currLayerID][0]>=0, "depth_nonlinear_representation_num_minus1 must be greater than or equal to 0");
@@ -1193,26 +1193,26 @@
     }
 
-    return wrongConfig; 
+    return wrongConfig;
 }
 #endif
 
 Void SEIMultiviewSceneInfo::setupFromCfgFile(const Char* cfgFile)
-{ 
+{
   // Set default values
-  IntAry1d defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes; 
-
-  // TBD: Add default values for which layers, POCS, Tids or Nalu types the SEI should be send. 
-  defAppLayerIds      .clear(); 
-  defAppPocs          .clear(); 
+  IntAry1d defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes;
+
+  // TBD: Add default values for which layers, POCS, Tids or Nalu types the SEI should be send.
+  defAppLayerIds      .clear();
+  defAppPocs          .clear();
   defAppTids          .push_back( 0 );
   defAppVclNaluTypes = IRAP_NAL_UNIT_TYPES;
 
-  Int      defSeiNaluId                  = 0; 
-  Int      defPositionInSeiNalu          = 0; 
-  Bool     defModifyByEncoder            = false; 
+  Int      defSeiNaluId                  = 0;
+  Int      defPositionInSeiNalu          = 0;
+  Bool     defModifyByEncoder            = false;
 
   // Setup config file options
-  po::Options opts;     
-  xAddGeneralOpts( opts , defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes, defSeiNaluId, defPositionInSeiNalu, defModifyByEncoder ); 
+  po::Options opts;
+  xAddGeneralOpts( opts , defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes, defSeiNaluId, defPositionInSeiNalu, defModifyByEncoder );
 
   opts.addOptions()
@@ -1225,40 +1225,40 @@
   // Parse the cfg file
   po::ErrorReporter err;
-  po::parseConfigFile( opts, cfgFile, err );  
+  po::parseConfigFile( opts, cfgFile, err );
 };
 
 
 Bool SEIMultiviewSceneInfo::checkCfg( const TComSlice* slice )
-{ 
+{
   // Check config values
-  Bool wrongConfig = false; 
-   
+  Bool wrongConfig = false;
+
   xCheckCfg     ( wrongConfig, slice->isIRAP(), "When present, the multiview scene information SEI message shall be associated with an IRAP access unit." );
-      
+
   xCheckCfgRange( wrongConfig, m_minDisparity              , -1024 , 1023, "min_disparity"                    );
   xCheckCfgRange( wrongConfig, m_maxDisparityRange         ,     0 , 2047, "max_disparity_range"              );
 
-  return wrongConfig; 
+  return wrongConfig;
 
 };
 
 Void SEIMultiviewAcquisitionInfo::setupFromCfgFile(const Char* cfgFile)
-{ 
+{
   // Set default values
-  IntAry1d defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes; 
-
-  defAppLayerIds    .clear(); 
+  IntAry1d defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes;
+
+  defAppLayerIds    .clear();
   defAppPocs        .push_back( 0 );
   defAppTids        .push_back( 0 );
   defAppVclNaluTypes = IDR_NAL_UNIT_TYPES;
-  
-
-  Int      defSeiNaluId                  = 0; 
-  Int      defPositionInSeiNalu          = 0; 
-  Bool     defModifyByEncoder            = false; 
+
+
+  Int      defSeiNaluId                  = 0;
+  Int      defPositionInSeiNalu          = 0;
+  Bool     defModifyByEncoder            = false;
 
   // Setup config file options
-  po::Options opts;     
-  xAddGeneralOpts( opts , defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes, defSeiNaluId, defPositionInSeiNalu, defModifyByEncoder ); 
+  po::Options opts;
+  xAddGeneralOpts( opts , defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes, defSeiNaluId, defPositionInSeiNalu, defModifyByEncoder );
 
   opts.addOptions()
@@ -1298,5 +1298,5 @@
   // Parse the cfg file
   po::ErrorReporter err;
-  po::parseConfigFile( opts, cfgFile, err );  
+  po::parseConfigFile( opts, cfgFile, err );
 };
 
@@ -1307,10 +1307,10 @@
 
 Bool SEIMultiviewAcquisitionInfo::checkCfg( const TComSlice* slice )
-{ 
+{
   // Check config values
-  Bool wrongConfig = false; 
-
-  // Currently the encoder starts with POC 0 for all layers. The condition on POC 0 should be changed, when this changes.   
-  xCheckCfg     ( wrongConfig, slice->isIRAP() && (slice->getPOC() == 0)  , "When present, the multiview acquisition information SEI message that applies to the current layer shall be included in an access unit that contains an IRAP picture that is the first picture of a CLVS of the current layer." );  
+  Bool wrongConfig = false;
+
+  // Currently the encoder starts with POC 0 for all layers. The condition on POC 0 should be changed, when this changes.
+  xCheckCfg     ( wrongConfig, slice->isIRAP() && (slice->getPOC() == 0)  , "When present, the multiview acquisition information SEI message that applies to the current layer shall be included in an access unit that contains an IRAP picture that is the first picture of a CLVS of the current layer." );
 
   xCheckCfgRange( wrongConfig, m_precFocalLength         , 0, 31, "prec_focal_length"         );
@@ -1319,5 +1319,5 @@
 
   for (Int i = 0; i <= getNumViewsMinus1(); i++ )
-  {  
+  {
     xCheckCfgRange( wrongConfig, m_exponentFocalLengthX    [ i ], 0, 62, "exponent_focal_length_x"   );
     xCheckCfgRange( wrongConfig, m_exponentFocalLengthY    [ i ], 0, 62, "exponent_focal_length_y"   );
@@ -1331,16 +1331,16 @@
 
   for (Int i = 0; i <= getNumViewsMinus1(); i++ )
-  {  
+  {
     for (Int j = 0; j <= 2; j++)
     {
       xCheckCfgRange( wrongConfig, m_exponentT[i][j]     , 0, 62, "exponent_skew_factor"      );
       for (Int k = 0; k <= 2; k++ )
-      {        
-        xCheckCfgRange( wrongConfig, m_exponentR[i][j][k], 0, 62, "exponent_principal_point_y");          
+      {
+        xCheckCfgRange( wrongConfig, m_exponentR[i][j][k], 0, 62, "exponent_principal_point_y");
       }
     }
-  }  
-
-  return wrongConfig; 
+  }
+
+  return wrongConfig;
 
 };
@@ -1378,5 +1378,5 @@
 UInt SEIMultiviewAcquisitionInfo::xGetSyntaxElementLen( Int expo, Int prec, Int val ) const
 {
-  UInt len; 
+  UInt len;
   if( expo == 0 )
   {
@@ -1388,17 +1388,17 @@
   }
 
-  assert( val >= 0 ); 
+  assert( val >= 0 );
   assert( val <= ( ( 1 << len )- 1) );
-  return len; 
+  return len;
 }
 
 Void SEIMultiviewViewPosition::setupFromSlice  ( const TComSlice* slice )
 {
-  const TComVPS* vps = slice->getVPS(); 
-  m_numViewsMinus1 = vps->getNumViews() - 1; 
-  m_viewPosition.resize( m_numViewsMinus1 + 1 ); 
+  const TComVPS* vps = slice->getVPS();
+  m_numViewsMinus1 = vps->getNumViews() - 1;
+  m_viewPosition.resize( m_numViewsMinus1 + 1 );
   for (Int i = 0; i <= m_numViewsMinus1; i++ )
   {
-    // Assuming that view ids indicate the position 
+    // Assuming that view ids indicate the position
     m_viewPosition[i] = vps->getViewIdVal( i );
   }
@@ -1406,24 +1406,24 @@
 
 Void SEIMultiviewViewPosition::setupFromCfgFile(const Char* cfgFile)
-{ 
+{
   // Set default values
-  IntAry1d defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes; 
+  IntAry1d defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes;
 
   defAppLayerIds    .push_back( 0 );
   defAppPocs        .push_back( 0 );
   defAppTids        .push_back( 0 );
-  defAppVclNaluTypes = IDR_NAL_UNIT_TYPES; 
-
-  Int      defSeiNaluId                  = 0; 
-  Int      defPositionInSeiNalu          = 0; 
-  Bool     defModifyByEncoder            = true; 
+  defAppVclNaluTypes = IDR_NAL_UNIT_TYPES;
+
+  Int      defSeiNaluId                  = 0;
+  Int      defPositionInSeiNalu          = 0;
+  Bool     defModifyByEncoder            = true;
 
   // Setup config file options
-  po::Options opts;     
-  xAddGeneralOpts( opts , defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes, defSeiNaluId, defPositionInSeiNalu, defModifyByEncoder ); 
+  po::Options opts;
+  xAddGeneralOpts( opts , defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes, defSeiNaluId, defPositionInSeiNalu, defModifyByEncoder );
 
   opts.addOptions()
     ("NumViewsMinus1"         , m_numViewsMinus1                          , 0                       , "NumViewsMinus1")
-    ("ViewPosition"           , m_viewPosition                            , IntAry1d (1,0)          , "ViewPosition"  ); 
+    ("ViewPosition"           , m_viewPosition                            , IntAry1d (1,0)          , "ViewPosition"  );
   ;
 
@@ -1436,12 +1436,12 @@
 
 Bool SEIMultiviewViewPosition::checkCfg( const TComSlice* slice )
-{ 
+{
   // Check config values
-  Bool wrongConfig = false; 
-
-  // TBD: Add constraints on presence of SEI here. 
+  Bool wrongConfig = false;
+
+  // TBD: Add constraints on presence of SEI here.
   xCheckCfg     ( wrongConfig, slice->isIRAP() , "When present, the multiview view position SEI message shall be associated with an IRAP access unit."  );
 
-  // TBD: Modify constraints according to the SEI semantics. 
+  // TBD: Modify constraints according to the SEI semantics.
   xCheckCfgRange( wrongConfig, m_numViewsMinus1                 , 0 , 62, "num_views_minus1");
   for(Int i = 0; i <= m_numViewsMinus1; i++)
@@ -1450,5 +1450,5 @@
   }
 
-  return wrongConfig; 
+  return wrongConfig;
 
 };
@@ -1457,7 +1457,7 @@
 #if NH_3D
 Void SEIAlternativeDepthInfo::setupFromCfgFile(const Char* cfgFile)
-{ 
+{
   // Set default values
-  IntAry1d defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes; 
+  IntAry1d defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes;
 
   defAppLayerIds    .clear();
@@ -1465,66 +1465,65 @@
   defAppTids        .clear();
   defAppVclNaluTypes.clear();
-    
-  Int      defSeiNaluId                  = 0; 
-  Int      defPositionInSeiNalu          = 0; 
-  Bool     defModifyByEncoder            = 0; 
+
+  Int      defSeiNaluId                  = 0;
+  Int      defPositionInSeiNalu          = 0;
+  Bool     defModifyByEncoder            = false;
 
   // Setup config file options
-  po::Options opts;     
-  xAddGeneralOpts( opts , defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes, defSeiNaluId, defPositionInSeiNalu, defModifyByEncoder ); 
-
+  po::Options opts;
+  xAddGeneralOpts( opts , defAppLayerIds, defAppPocs, defAppTids, defAppVclNaluTypes, defSeiNaluId, defPositionInSeiNalu, defModifyByEncoder );
+
+  // 3 = m_numConstituentViewsGvdMinus1 + 2
   opts.addOptions()
-    ("AlternativeDepthInfoCancelFlag"   , m_alternativeDepthInfoCancelFlag   , false                            , "AlternativeDepthInfoCancelFlag"   )
-    ("DepthType"                        , m_depthType                        , 1                                , "DepthType"                        )
-#if NH_MV_SEI_TBD
-    ("NumConstituentViewsGvdMinus1"     , m_numConstituentViewsGvdMinus1     , 0                                , "NumConstituentViewsGvdMinus1"     )
-    ("DepthPresentGvdFlag"              , m_depthPresentGvdFlag              , false                            , "DepthPresentGvdFlag"              )
-    ("ZGvdFlag"                         , m_zGvdFlag                         , false                            , "ZGvdFlag"                         )
-    ("IntrinsicParamGvdFlag"            , m_intrinsicParamGvdFlag            , false                            , "IntrinsicParamGvdFlag"            )
-    ("RotationGvdFlag"                  , m_rotationGvdFlag                  , false                            , "RotationGvdFlag"                  )
-    ("TranslationGvdFlag"               , m_translationGvdFlag               , false                            , "TranslationGvdFlag"               )
-    ("SignGvdZNearFlag"                 , m_signGvdZNearFlag                 , BoolAry1d(1,0)                   , "SignGvdZNearFlag"                 )
-    ("ExpGvdZNear"                      , m_expGvdZNear                      , IntAry1d (1,0)                   , "ExpGvdZNear"                      )
-    ("ManLenGvdZNearMinus1"             , m_manLenGvdZNearMinus1             , IntAry1d (1,0)                   , "ManLenGvdZNearMinus1"             )
-    ("ManGvdZNear"                      , m_manGvdZNear                      , IntAry1d (1,0)                   , "ManGvdZNear"                      )
-    ("SignGvdZFarFlag"                  , m_signGvdZFarFlag                  , BoolAry1d(1,0)                   , "SignGvdZFarFlag"                  )
-    ("ExpGvdZFar"                       , m_expGvdZFar                       , IntAry1d (1,0)                   , "ExpGvdZFar"                       )
-    ("ManLenGvdZFarMinus1"              , m_manLenGvdZFarMinus1              , IntAry1d (1,0)                   , "ManLenGvdZFarMinus1"              )
-    ("ManGvdZFar"                       , m_manGvdZFar                       , IntAry1d (1,0)                   , "ManGvdZFar"                       )
-    ("PrecGvdFocalLength"               , m_precGvdFocalLength               , 0                                , "PrecGvdFocalLength"               )
-    ("PrecGvdPrincipalPoint"            , m_precGvdPrincipalPoint            , 0                                , "PrecGvdPrincipalPoint"            )
-    ("PrecGvdRotationParam"             , m_precGvdRotationParam             , 0                                , "PrecGvdRotationParam"             )
-    ("PrecGvdTranslationParam"          , m_precGvdTranslationParam          , 0                                , "PrecGvdTranslationParam"          )
-    ("SignGvdFocalLengthX"              , m_signGvdFocalLengthX              , BoolAry1d(1,0)                   , "SignGvdFocalLengthX"              )
-    ("ExpGvdFocalLengthX"               , m_expGvdFocalLengthX               , IntAry1d (1,0)                   , "ExpGvdFocalLengthX"               )
-    ("ManGvdFocalLengthX"               , m_manGvdFocalLengthX               , IntAry1d (1,0)                   , "ManGvdFocalLengthX"               )
-    ("SignGvdFocalLengthY"              , m_signGvdFocalLengthY              , BoolAry1d(1,0)                   , "SignGvdFocalLengthY"              )
-    ("ExpGvdFocalLengthY"               , m_expGvdFocalLengthY               , IntAry1d (1,0)                   , "ExpGvdFocalLengthY"               )
-    ("ManGvdFocalLengthY"               , m_manGvdFocalLengthY               , IntAry1d (1,0)                   , "ManGvdFocalLengthY"               )
-    ("SignGvdPrincipalPointX"           , m_signGvdPrincipalPointX           , BoolAry1d(1,0)                   , "SignGvdPrincipalPointX"           )
-    ("ExpGvdPrincipalPointX"            , m_expGvdPrincipalPointX            , IntAry1d (1,0)                   , "ExpGvdPrincipalPointX"            )
-    ("ManGvdPrincipalPointX"            , m_manGvdPrincipalPointX            , IntAry1d (1,0)                   , "ManGvdPrincipalPointX"            )
-    ("SignGvdPrincipalPointY"           , m_signGvdPrincipalPointY           , BoolAry1d(1,0)                   , "SignGvdPrincipalPointY"           )
-    ("ExpGvdPrincipalPointY"            , m_expGvdPrincipalPointY            , IntAry1d (1,0)                   , "ExpGvdPrincipalPointY"            )
-    ("ManGvdPrincipalPointY"            , m_manGvdPrincipalPointY            , IntAry1d (1,0)                   , "ManGvdPrincipalPointY"            )
-    ("SignGvdR"                         , m_signGvdR                         , BoolAry1d(1,0)   ,ADDNUM ,ADDNUM , "SignGvdR"                         )
-    ("ExpGvdR"                          , m_expGvdR                          , IntAry1d (1,0)   ,ADDNUM ,ADDNUM , "ExpGvdR"                          )
-    ("ManGvdR"                          , m_manGvdR                          , IntAry1d (1,0)   ,ADDNUM ,ADDNUM , "ManGvdR"                          )
-    ("SignGvdTX"                        , m_signGvdTX                        , BoolAry1d(1,0)                   , "SignGvdTX"                        )
-    ("ExpGvdTX"                         , m_expGvdTX                         , IntAry1d (1,0)                   , "ExpGvdTX"                         )
-    ("ManGvdTX"                         , m_manGvdTX                         , IntAry1d (1,0)                   , "ManGvdTX"                         )
-#endif
-    ("MinOffsetXInt"                    , m_minOffsetXInt                    , 0                                , "MinOffsetXInt"                    )
-    ("MinOffsetXFrac"                   , m_minOffsetXFrac                   , 0                                , "MinOffsetXFrac"                   )
-    ("MaxOffsetXInt"                    , m_maxOffsetXInt                    , 0                                , "MaxOffsetXInt"                    )
-    ("MaxOffsetXFrac"                   , m_maxOffsetXFrac                   , 0                                , "MaxOffsetXFrac"                   )
-    ("OffsetYPresentFlag"               , m_offsetYPresentFlag               , false                            , "OffsetYPresentFlag"               )
-    ("MinOffsetYInt"                    , m_minOffsetYInt                    , 0                                , "MinOffsetYInt"                    )
-    ("MinOffsetYFrac"                   , m_minOffsetYFrac                   , 0                                , "MinOffsetYFrac"                   )
-    ("MaxOffsetYInt"                    , m_maxOffsetYInt                    , 0                                , "MaxOffsetYInt"                    )
-    ("MaxOffsetYFrac"                   , m_maxOffsetYFrac                   , 0                                , "MaxOffsetYFrac"                   )
-    ("WarpMapSizePresentFlag"           , m_warpMapSizePresentFlag           , false                            , "WarpMapSizePresentFlag"           )
-    ("WarpMapWidthMinus2"               , m_warpMapWidthMinus2               , 0                                , "WarpMapWidthMinus2"               )
-    ("WarpMapHeightMinus2"              , m_warpMapHeightMinus2              , 0                                , "WarpMapHeightMinus2"              )
+    ("AlternativeDepthInfoCancelFlag" , m_alternativeDepthInfoCancelFlag  , false               , "AlternativeDepthInfoCancelFlag"  )
+    ("DepthType"                      , m_depthType                       , 1                   , "DepthType"                       )
+    ("NumConstituentViewsGvdMinus1"   , m_numConstituentViewsGvdMinus1    , 1                   , "NumConstituentViewsGvdMinus1"    )
+    ("DepthPresentGvdFlag"            , m_depthPresentGvdFlag             , false               , "DepthPresentGvdFlag"             )
+    ("ZGvdFlag"                       , m_zGvdFlag                        , false               , "ZGvdFlag"                        )
+    ("IntrinsicParamGvdFlag"          , m_intrinsicParamGvdFlag           , false               , "IntrinsicParamGvdFlag"           )
+    ("RotationGvdFlag"                , m_rotationGvdFlag                 , false               , "RotationGvdFlag"                 )
+    ("TranslationGvdFlag"             , m_translationGvdFlag              , false               , "TranslationGvdFlag"              )
+    ("SignGvdZNearFlag_%d"            , m_signGvdZNearFlag                , BoolAry1d(3,0), 3   , "SignGvdZNearFlag"                )
+    ("ExpGvdZNear_%d"                 , m_expGvdZNear                     , IntAry1d (3,0), 3   , "ExpGvdZNear"                     )
+    ("ManLenGvdZNearMinus1_%d"        , m_manLenGvdZNearMinus1            , IntAry1d (3,0), 3   , "ManLenGvdZNearMinus1"            )
+    ("ManGvdZNear_%d"                 , m_manGvdZNear                     , IntAry1d (3,0), 3   , "ManGvdZNear"                     )
+    ("SignGvdZFarFlag_%d"             , m_signGvdZFarFlag                 , BoolAry1d(3,0), 3   , "SignGvdZFarFlag"                 )
+    ("ExpGvdZFar_%d"                  , m_expGvdZFar                      , IntAry1d (3,0), 3   , "ExpGvdZFar"                      )
+    ("ManLenGvdZFarMinus1_%d"         , m_manLenGvdZFarMinus1             , IntAry1d (3,0), 3   , "ManLenGvdZFarMinus1"             )
+    ("ManGvdZFar_%d"                  , m_manGvdZFar                      , IntAry1d (3,0), 3   , "ManGvdZFar"                      )
+    ("PrecGvdFocalLength"             , m_precGvdFocalLength              , 18                  , "PrecGvdFocalLength"              )
+    ("PrecGvdPrincipalPoint"          , m_precGvdPrincipalPoint           , 18                  , "PrecGvdPrincipalPoint"           )
+    ("PrecGvdRotationParam"           , m_precGvdRotationParam            , 18                  , "PrecGvdRotationParam"            )
+    ("PrecGvdTranslationParam"        , m_precGvdTranslationParam         , 18                  , "PrecGvdTranslationParam"         )
+    ("SignGvdFocalLengthX_%d"         , m_signGvdFocalLengthX             , BoolAry1d(3,0), 3   ,"SignGvdFocalLengthX"              )
+    ("ExpGvdFocalLengthX_%d"          , m_expGvdFocalLengthX              , IntAry1d (3,0), 3   ,"ExpGvdFocalLengthX"               )
+    ("ManGvdFocalLengthX_%d"          , m_manGvdFocalLengthX              , IntAry1d (3,0), 3   ,"ManGvdFocalLengthX"               )
+    ("SignGvdFocalLengthY_%d"         , m_signGvdFocalLengthY             , BoolAry1d(3,0), 3   ,"SignGvdFocalLengthY"              )
+    ("ExpGvdFocalLengthY_%d"          , m_expGvdFocalLengthY              , IntAry1d (3,0), 3   ,"ExpGvdFocalLengthY"               )
+    ("ManGvdFocalLengthY_%d"          , m_manGvdFocalLengthY              , IntAry1d (3,0), 3   ,"ManGvdFocalLengthY"               )
+    ("SignGvdPrincipalPointX_%d"      , m_signGvdPrincipalPointX          , BoolAry1d(3,0), 3   ,"SignGvdPrincipalPointX"           )
+    ("ExpGvdPrincipalPointX_%d"       , m_expGvdPrincipalPointX           , IntAry1d (3,0), 3   ,"ExpGvdPrincipalPointX"            )
+    ("ManGvdPrincipalPointX_%d"       , m_manGvdPrincipalPointX           , IntAry1d (3,0), 3   ,"ManGvdPrincipalPointX"            )
+    ("SignGvdPrincipalPointY_%d"      , m_signGvdPrincipalPointY          , BoolAry1d(3,0), 3   ,"SignGvdPrincipalPointY"           )
+    ("ExpGvdPrincipalPointY_%d"       , m_expGvdPrincipalPointY           , IntAry1d (3,0), 3   ,"ExpGvdPrincipalPointY"            )
+    ("ManGvdPrincipalPointY_%d"       , m_manGvdPrincipalPointY           , IntAry1d (3,0), 3   ,"ManGvdPrincipalPointY"            )
+    ("SignGvdR_%d_%d"                 , m_signGvdR                        , BoolAry1d(3,0), 3, 3,"SignGvdR"                         )
+    ("ExpGvdR_%d_%d"                  , m_expGvdR                         , IntAry1d (3,0), 3, 3,"ExpGvdR"                          )
+    ("ManGvdR_%d_%d"                  , m_manGvdR                         , IntAry1d (3,0), 3, 3,"ManGvdR"                          )
+    ("SignGvdTX_%d"                   , m_signGvdTX                       , BoolAry1d(3,0), 3   ,"SignGvdTX"                        )
+    ("ExpGvdTX_%d"                    , m_expGvdTX                        , IntAry1d (3,0), 3   ,"ExpGvdTX"                         )
+    ("ManGvdTX_%d"                    , m_manGvdTX                        , IntAry1d (3,0), 3   ,"ManGvdTX"                         )
+    ("MinOffsetXInt"                  , m_minOffsetXInt                   , 0                   , "MinOffsetXInt"                   )
+    ("MinOffsetXFrac"                 , m_minOffsetXFrac                  , 0                   , "MinOffsetXFrac"                  )
+    ("MaxOffsetXInt"                  , m_maxOffsetXInt                   , 0                   , "MaxOffsetXInt"                   )
+    ("MaxOffsetXFrac"                 , m_maxOffsetXFrac                  , 0                   , "MaxOffsetXFrac"                  )
+    ("OffsetYPresentFlag"             , m_offsetYPresentFlag              , false               , "OffsetYPresentFlag"              )
+    ("MinOffsetYInt"                  , m_minOffsetYInt                   , 0                   , "MinOffsetYInt"                   )
+    ("MinOffsetYFrac"                 , m_minOffsetYFrac                  , 0                   , "MinOffsetYFrac"                  )
+    ("MaxOffsetYInt"                  , m_maxOffsetYInt                   , 0                   , "MaxOffsetYInt"                   )
+    ("MaxOffsetYFrac"                 , m_maxOffsetYFrac                  , 0                   , "MaxOffsetYFrac"                  )
+    ("WarpMapSizePresentFlag"         , m_warpMapSizePresentFlag          , false               , "WarpMapSizePresentFlag"          )
+    ("WarpMapWidthMinus2"             , m_warpMapWidthMinus2              , 0                   , "WarpMapWidthMinus2"              )
+    ("WarpMapHeightMinus2"            , m_warpMapHeightMinus2             , 0                   , "WarpMapHeightMinus2"             )
     ;
 
